TOPDIR		= ../../../..
SOURCE		= .
PROG		= son
TARGET		= $(TOPDIR)/target/lib/$(PROG)
LIBRARIES	= $(TOPDIR)/target/lib
TMP		= /tmp

GEN_CFLAGS	= 
PROG_CFLAGS	= -I../../include
SON_CFLAGS	=

EXT		= o
CP		= cp
CC		= cc
MV		= mv
RM		= rm -f
OPTIMIZE	=
OPTS		=
PRODUCTS	= $(LIBRARIES)/lib$(PROG).a
MAKEFILE	= makefile
AR		= ar
AR_OPT		= rcv
RANLIB		= ranlib


############# LOCAL DEFINITIONS - BEGIN

# SUN
# TARGET = .
# EXECUTABLES = .
# DEFINES = -DUNIX -DSPARC -DSUN -DMALLOC_H
# OPTS = -g
# MV = echo
# LIBRARIES = .

# APOLLO
# DEFINES = -DUNIX -DAPOLLO -DAP3 -DNO_MALLOC_H

############# LOCAL DEFINITIONS END 

DVX			= C:/dvx
HIGHC			= C:/highc
PHAR386			= C:/phar386
COPROCESSOR		= 387
CC		= hc386
AR		= 386lib
LD		= 386link
BIND		= bind386
BIND_MODULE	= $(PHAR386)/bin/run386b.exe
MFG		= 
TARGET		= $(MFG)/target/lib/$(PROG)
EXT		= obj
PRODUCTS	= $(LIBRARIES)/lib$(PROG).lib
MV		= mv
DEFINES		= -DDOS 
GEN_CFLAGS	= @cflags.rsp -f$(COPROCESSOR)


STD_DEFINES	= 
CFLAGS		= $(CDBUGFLAGS) $(INCLUDES) $(STD_DEFINES) $(DEFINES) \
		  $(OPTS) $(OPTIMIZE) $(SON_CFLAGS) $(PROG_CFLAGS) $(GEN_CFLAGS)

HEADERS = \
		son.h


OBJS = \
		$(TARGET)/bug.$(EXT) \
		$(TARGET)/ver.$(EXT) \
		$(TARGET)/clock.$(EXT) \
		$(TARGET)/expstr.$(EXT) \
		$(TARGET)/new.$(EXT) \
		$(TARGET)/strutil.$(EXT)

SRC = \
		$(SOURCE)/bug.c \
		$(SOURCE)/ver.c \
		$(SOURCE)/clock.c \
		$(SOURCE)/expstr.c \
		$(SOURCE)/new.c \
		$(SOURCE)/strutil.c

DOS_OBJS =  \
		$(TARGET)/sleep.$(EXT) \
		$(TARGET)/hldos.$(EXT) \
		$(TARGET)/dos.$(EXT)

DOS_SRC =  \
		$(SOURCE)/sleep.c \
		$(SOURCE)/hldos.c \
		$(SOURCE)/dos.c


MEXPSTR_OBJS = \
		$(TARGET)/mexpstr.$(EXT)



#################################
#           			#
#           BUILD LIBRARY     	#
#           			#
#################################

all::	$(PRODUCTS)


$(LIBRARIES)/lib$(PROG).a:	$(OBJS)
		$(AR) $(AR_OPT) $(LIBRARIES)/lib$(PROG).a $(OBJS)
		$(RANLIB) $(LIBRARIES)/lib$(PROG).a



#################################
#           			#
#        DOS SUPPORT		#
#           			#
#################################

objs.rsp::
	echo "-CREATE" > objs.rsp
	echo $(OBJS) $(DOS_OBJS) | dosobj | sed "s+^+../+" >> objs.rsp

cflags.rsp::
	> cflags.rsp
	echo -O5                                >> cflags.rsp
	echo -Hoff=Low_level_scheduling         >> cflags.rsp
	echo -w                                 >> cflags.rsp
	echo -486                               >> cflags.rsp
	echo -Hnocopyr                          >> cflags.rsp
	echo -Hon=Pointers_compatible           >> cflags.rsp
	echo -Hon=Pointers_compatible_with_ints >> cflags.rsp
	echo -DMSDOS                            >> cflags.rsp
	echo -I$(DVX)/include                	>> cflags.rsp
	echo -I../include                	>> cflags.rsp 
	

link.rsp::
	> link.rsp

$(LIBRARIES)/lib$(PROG).lib:	$(OBJS) $(DOS_OBJS) objs.rsp
		$(AR) $(LIBRARIES)/lib$(PROG).lib @objs.rsp

####
####
####   BUILD OBJECT FILES
####
####

$(TARGET)/strutil.$(EXT): strutil.c $(HEADERS)
		$(CC) strutil.c $(CFLAGS) -c
		$(MV) strutil.$(EXT) $(TARGET)

$(TARGET)/new.$(EXT): 	new.c $(HEADERS)
		$(CC) new.c $(CFLAGS) -c
		$(MV) new.$(EXT) $(TARGET)

$(TARGET)/bug.$(EXT): bug.c $(HEADERS)
		$(CC) bug.c $(CFLAGS) -c
		$(MV) bug.$(EXT) $(TARGET)

$(TARGET)/ver.$(EXT): ver.c $(HEADERS)
		$(CC) ver.c $(CFLAGS) -c
		$(MV) ver.$(EXT) $(TARGET)

$(TARGET)/clock.$(EXT):    clock.c $(HEADERS)
		$(CC) clock.c $(CFLAGS) -c
		$(MV) clock.$(EXT) $(TARGET)

$(TARGET)/expstr.$(EXT):   expstr.c $(HEADERS)
		$(CC) expstr.c $(CFLAGS) -c
		$(MV) expstr.$(EXT) $(TARGET)

$(TARGET)/hldos.$(EXT):   hldos.c   
		$(CC) hldos.c $(CFLAGS) -c
		$(MV) hldos.$(EXT) $(TARGET)

$(TARGET)/sleep.$(EXT):   sleep.c $(HEADERS)
		$(CC) sleep.c $(CFLAGS) -c
		$(MV) sleep.$(EXT) $(TARGET)

$(TARGET)/dos.$(EXT):   dos.c $(HEADERS)
		$(CC) dos.c $(CFLAGS) -c
		$(MV) dos.$(EXT) $(TARGET)

#### Programs used in debugging and testing


$(TARGET)/mexpstr.$(EXT):   mexpstr.c $(HEADERS)
		$(CC) mexpstr.c $(CFLAGS) -c
		$(MV) mexpstr.$(EXT) $(TARGET)

clean::
		$(RM) $(TARGET)/*.o $(PRODUCTS) $(TARGET)/*.tags

lint::
	lint $(DEFINES) $(STD_DEFINES) -DUNIX $(SRC)
	 
son.inp: makefile
	echo "defineg DOS"              > son.inp
	echo "defineg EXCLUDE_VEC"      >> son.inp
	echo "defineg MALLOC_H"         >> son.inp
	echo "defineg NO_EM_SECURITY"   >> son.inp
	echo "defineg PWD_H"   		>> son.inp
	echo "ipath /base/src/include;c:/dvx/include;c:/c600/include" >> son.inp
	ls $(SRC) $(DOS_SRC)|grep -v sleep| sed "s+$(SOURCE)/++g" | sed "s/^/load /" >> son.inp
	echo Created son.inp
	echo -LIB $(HIGHC)/small/hc$(COPROCESSOR) >> link.rsp
	echo -LIB $(HIGHC)/small/hcloc          >> link.rsp
	echo -LIB $(HIGHC)/small/hc386          >> link.rsp
	echo -LIB $(HIGHC)/small/hcna           >> link.rsp
	echo -LIB C:/glenco/hl386hc.lib         >> link.rsp
	echo -STACK 40000                       >> link.rsp
	echo -cvsymbols                         >> link.rsp
	echo -priv                         	>> link.rsp 
